.686p
.model  flat, stdcall
option Casemap :None    
.nolist
include windows.inc

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM
uselib user32
uselib kernel32
uselib comctl32
uselib gdi32
uselib comdlg32

inv equ invoke
.list
.data
ClassName       DB "StdWindow",0
szAppName       DB "Exe Application",0
wc WNDCLASS <CS_HREDRAW or CS_VREDRAW,WndProc,0,0,0,0,0,COLOR_WINDOW+1,0,ClassName>

.data?
hInst   dd ?
hWindow dd ?
hWin    dd ?
hMenu   dd ?
hwindow dd ? 
message MSG <>
;CmdLine dd ?

define Macro IdString  ;; helper macro to take defines from rc file
    local Id,IdVal,BlankPos
	BlankPos instr <IdString>,< >
	Id substr <IdString>,1,BlankPos-1
	IdVal substr <IdString>,BlankPos
    Id = IdVal
EndM

define MNU 2000
define zFileNew 2011
define zPng 2012
define zBmp 2013
define zGif 2014
define zTif 2015
define zJpg 2016
define zFileExit 2020

.code
Program:
    inv GetModuleHandle, 0
    mov hInst,eax
    mov wc.hInstance,eax   ; save for later
    ;inv GetCommandLine
    ;mov CmdLine, eax
    inv LoadIcon, 0, IDI_APPLICATION
    mov wc.hIcon,eax
    inv LoadCursor, 0, IDC_ARROW
    mov wc.hCursor,eax
    inv RegisterClass, addr wc
    inv LoadMenu, hInst, MNU
    mov hMenu,eax
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr szAppName,WS_OVERLAPPEDWINDOW,
           CW_USEDEFAULT,CW_USEDEFAULT,400,150,0,hMenu,hInst,0
    mov hWindow,eax
    inv ShowWindow, hWindow, SW_SHOWNORMAL
    inv UpdateWindow, hWindow
    .repeat
        inv GetMessage,addr message,0,0,0
        .break .if !eax
        inv TranslateMessage,addr message
        inv DispatchMessage,addr message
    .until 0
    inv ExitProcess,message.wParam
    
;--------------------------------------
include GetMyBitmap.inc
;--------------------------------------

.data?
btmap   BITMAP <>
bwidth  equ btmap.bmWidth   ; width of images
bheight equ btmap.bmHeight  ; height of images
bitsptr dd ?
hdib    dd ?
mdc     dd ?
hbmp    dd ?
.data
bih   BITMAPINFOHEADER <sizeof BITMAPINFOHEADER,0,0,1,32,BI_RGB,0,0,0,0,0>
.code

UpdateMdc proc ResourceId,FileName ; update the hidden memory buffer with a new image
    ; if ResourceId==0, use filename, else get resource
    local hdc,tdc,tloc
    .if mdc
        inv ReleaseDC,hWin,mdc
        inv DeleteObject,hdib
    .endif
    mov hbmp,0
    inv GetMyBitmap,ResourceId,FileName,addr hbmp,addr tloc
    .if hbmp==0
        invoke MessageBox,0,tloc,0,0
        ret
    .endif

    inv GetObject,hbmp,sizeof btmap,addr btmap
    inv GetDC,hWin      ; get dc of window
    mov hdc,eax
    inv CreateCompatibleDC,hdc
    mov tdc,eax         ; temp dc for bitmap manipulation
    inv SelectObject,tdc,hbmp   ; load it in so we can do something with it
    push bwidth 
    pop bih.BITMAPINFOHEADER.biWidth  ; set width and height in bitmapinfoheader
    mov eax,bheight     ; so we can make a dib
    neg eax             ; dibs are backward
    mov bih.BITMAPINFOHEADER.biHeight,eax
    inv CreateDIBSection,hdc,addr bih,DIB_RGB_COLORS,addr bitsptr,0,0
    mov hdib,eax    ; something we can reference directly
    inv GetDIBits,tdc,hbmp,0,bheight,bitsptr,addr bih,DIB_RGB_COLORS ; now copy bitmap to dib    
    inv CreateCompatibleDC,hdc  ; setup a hidden memory dc buffer for updating the screen
    mov mdc,eax
    inv SelectObject,mdc,hdib   ; associate with the dib
    inv DeleteObject,hbmp
    inv DeleteDC,tdc
    mov hbmp,0
    inv ReleaseDC,hWin,hdc
    inv InvalidateRect,hWin,0,1	
	ret
UpdateMdc endp
 
WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    local hdc,ps:PAINTSTRUCT
    .if uMsg==WM_COMMAND
        mov eax,wParam
        .if ax==zFileNew
            call GetFileName
            mov edx,afilename
            inv UpdateMdc,0,edx
        .elseif ax==zPng
            inv UpdateMdc,301,0
        .elseif ax==zBmp
            inv UpdateMdc,302,0
        .elseif ax==zGif
            inv UpdateMdc,303,0
        .elseif ax==zTif
            inv UpdateMdc,304,0
        .elseif ax==zJpg
            inv UpdateMdc,305,0
        .elseif ax==zFileExit
            invoke SendMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,0
        .endif
    .elseif uMsg==WM_CREATE
        mov eax,hWnd
        mov hWin,eax  ; good from now on
        inv UpdateMdc,301,0  ; get the png for a start

    .elseif uMsg==WM_PAINT
        
        inv BeginPaint,hWnd,addr ps
        mov hdc,eax
        inv BitBlt,hdc,0,0,bwidth,bheight,mdc,0,0,SRCCOPY
        inv EndPaint,hWnd,addr ps

    .elseif uMsg==WM_CLOSE
        .if mdc
            inv ReleaseDC,hWin,mdc
            inv DeleteObject,hdib
        .endif
    .elseif uMsg==WM_DESTROY
        inv PostQuitMessage,0
        mov eax,wParam
        jmp WndRet
    .endif
    inv DefWindowProc, hWnd, uMsg, wParam, lParam
WndRet:
    ret
WndProc EndP


.data?
maxf equ MAX_PATH+4
TmpName dd maxf dup (?)
.data
Filt db "Image Files",0,"*.bmp;*.jpg;*.gif;*.png;*.tif",0,0
ext  db 4 dup (0)
align 4
TitNam db maxf dup (0)
ofn OPENFILENAME <sizeof OPENFILENAME, \
 0, \   ;hwndOwner
 0, \   ;hInstance
 offset Filt,\ ;lpstrFilter
 0, \   ;lpstrCustomFilter
 0, \   ;nMaxCustFilter
 0, \   ;nFilterIndex
 offset TmpName,\ ;lpstrFile
 maxf,\ ;nMaxFile
 offset TitNam,\ ;lpstrFileTitle
 maxf,\ ;nMaxFileTitle
 0, \   ;lpstrInitialDir
 0, \   ;lpstrTitle
 0, \   ;Flags
 0, \   ;nFileOffset (WORD)
 0, \   ;nFileExtension (WORD)
 offset ext,\ ;lpstrDefExt
 0, \   ;lCustData
 0, \   ;lpfnHook
 0>     ;lpTemplateName
ofnparent dd 0
Oldofn dd 0
PromptFile db "Find and Select an image file",0
OFPos     db "OFPos",0
FileData  db "FileData",0   
afilename dd offset FileName
.data?
align 4
FileName db maxf dup (?)
OFSave RECT <?>     ; old saved position for open file dialog
SHSave RECT <?>     ; old saved position
DefSourceFolder db maxf dup (?)
.code

GetFileName proc
    inv lstrcpy,addr TmpName,afilename
    mov eax,hWin
    mov ofn.hWndOwner,eax
    OFN_ENABLESIZING equ 800000h
    mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_ENABLEHOOK or OFN_EXPLORER or OFN_ENABLESIZING
    mov ofn.lpstrInitialDir,offset DefSourceFolder ; use this if ProjectSource not set
    mov ofn.nMaxFile,maxf
    mov ofn.lpfnHook,offset GetFileDlgProc
    mov TitNam,0
    inv GetOpenFileName,addr ofn
    push eax
    .if eax
        inv lstrcpy,afilename,addr TmpName
    .endif
    pop eax    
    ret
GetFileName endp

OFsub proc hofn:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD  ; subclass open file common dialog
    .if uMsg == WM_SIZE || uMsg== WM_MOVE
        inv GetWindowRect,hofn,addr OFSave
    .endif
    inv CallWindowProc,Oldofn,hofn,uMsg,wParam,lParam

    ret
OFsub EndP
GetFileDlgProc proc hDlg:dword, uMsg:dword, wParam:dword, lParam:dword
    local wp:WINDOWPLACEMENT
    .if uMsg==WM_INITDIALOG
        inv GetParent,hDlg
        mov ofnparent,eax

        ;inv SendMessage,ofnparent,CDM_HIDECONTROL,cmb1,0
        ;inv SendMessage,ofnparent,CDM_HIDECONTROL,stc2,0
        ;inv SendMessage,ofnparent,CDM_HIDECONTROL,stc4,0
        ;inv SendMessage,ofnparent,CDM_HIDECONTROL,edt1,0
        ;inv SendMessage,ofnparent,CDM_HIDECONTROL,stc3,0
        inv SetWindowText,ofnparent,addr PromptFile

        mov wp.iLength,sizeof WINDOWPLACEMENT
        inv GetDlgItem,ofnparent,IDOK
        mov edx,eax
        inv GetWindowPlacement,edx,addr wp
        mov eax,wp.rcNormalPosition.right
        sub eax,wp.rcNormalPosition.left
        add eax,10  ; space between
        sub wp.rcNormalPosition.left,eax
        sub wp.rcNormalPosition.right,eax
        inv GetDlgItem,ofnparent,IDCANCEL
        mov edx,eax
;        inv SetWindowPlacement,edx,addr wp

        inv PostMessage,hDlg,WM_USER+201,0,0  ; let me know when settled
    .elseif uMsg==WM_USER+201   ; position window to user preferences
        inv SetWindowLong,ofnparent,GWL_WNDPROC,OFsub  ; subclass first
        mov Oldofn,eax      ; save old routine
        mov eax,OFSave.bottom
        sub eax,OFSave.top
        mov edx,OFSave.right
        sub edx,OFSave.left
        inv SetWindowPos,ofnparent,0,OFSave.left,OFSave.top,edx,eax,SWP_NOZORDER  ; resize and reposition window    

;   .elseif uMsg==WM_NOTIFY
;       mov   eax, lParam
;       mov   eax, [eax].NMHDR.code
    .endif
    xor eax,eax ;pass along message
    ret
GetFileDlgProc EndP

End Program